﻿using Amazon.Polly;
using Amazon.Polly.Model;
using Amazon.Translate;
using Amazon.Translate.Model;
using NetCoreAudio;

var translateClient = new AmazonTranslateClient();
var translateRequest = new TranslateTextRequest
{
    SourceLanguageCode = "en",
    TargetLanguageCode = "es",
};

var pollyClient = new AmazonPollyClient();
var pollyRequest = new SynthesizeSpeechRequest
{
    OutputFormat = OutputFormat.Mp3,
    VoiceId = VoiceId.Lucia,
};

var player = new Player();


while (true)
{
    Console.WriteLine("Enter text to translate (CTRL-C to exit):");
    var text = Console.ReadLine();
    translateRequest.Text = text;
    var translateResponse = await translateClient.TranslateTextAsync(translateRequest);
    Console.WriteLine($"Translated text: {translateResponse.TranslatedText}\n");
    await TextToSpeech(translateResponse.TranslatedText); 
}

async Task TextToSpeech(string translatedText)
{
    pollyRequest.Text = translatedText;
    
    var response = await pollyClient.SynthesizeSpeechAsync(pollyRequest);

    using (var fileStream = new FileStream("speech.mp3", FileMode.Create, FileAccess.Write))
    {
        response.AudioStream.CopyTo(fileStream);
    }

    await player.Play("speech.mp3");
}
